// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, fs, mkdirp, path, request;

  fs = require('fs');

  mkdirp = require('mkdirp');

  path = require('path');

  request = require('sync-request');

  QedaElement = require('../qeda-element');

  module.exports = {
    _initElements: function() {
      this.symbolDefs = [
        {
          regexp: /IC2/,
          handler: 'ic2'
        }
      ];
      this.patternDefs = [
        {
          regexp: /SOP(\d+)P(\d+)X(\d+)-(\d+)/,
          handler: 'sm/soic'
        }, {
          regexp: /SOIC(\d+)P(\d+)X(\d+)-(\d+)/,
          handler: 'sm/soic'
        }
      ];
      return this.elements = [];
    },
    add: function(element) {
      var description, elementJson, localFile, newElement, res;
      elementJson = element.toLowerCase() + '.json';
      localFile = './library/' + elementJson;
      if (!fs.existsSync(localFile)) {
        res = request('GET', 'https://raw.githubusercontent.com/qeda/library/master/' + elementJson, {
          timeout: 3000
        });
        if (res.statusCode === 200) {
          mkdirp.sync(path.dirname(localFile));
          fs.writeFileSync(localFile, res.body);
          console.log("Loading '" + element + "': OK");
        } else {
          console.error("Loading '" + element + "': Error (" + res.statusCode + ")");
          process.exit(1);
        }
      }
      description = JSON.parse(fs.readFileSync(localFile));
      newElement = new QedaElement(this, description);
      this.elements.push(newElement);
      return newElement;
    },
    addPatternDefinition: function(regexp, handler) {
      return this.patternDefs.push({
        regexp: regexp,
        handler: handler
      });
    }
  };

}).call(this);
