// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement,
    slice = [].slice;

  QedaElement = (function() {
    function QedaElement(lib, def) {
      var cap, handler, i, j, len, len1, p, ref, ref1, s;
      this.lib = lib;
      this.def = def;
      this.patterns = [];
      this.pattern = [];
      this.layer = 'top';
      this.name = this.def.name;
      this.refDes = 'E';
      if (this.def.symbol) {
        ref = this.lib.symbolDefs;
        for (i = 0, len = ref.length; i < len; i++) {
          s = ref[i];
          cap = s.regexp.exec(this.def.symbol);
          if (cap) {
            handler = require("./symbol/" + this.lib.symbolStyle + "/" + s.handler);
            handler.apply(null, [this].concat(slice.call(cap.slice(1))));
          }
        }
      }
      if (!Array.isArray(this.def["package"])) {
        this.def["package"] = [this.def["package"]];
      }
      ref1 = this.def["package"];
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        p = ref1[j];
        if (typeof p === 'object') {
          this.addPattern(p);
        } else if (typeof p === 'string') {
          if (this.def[p] != null) {
            this.addPattern(this.def[p]);
          }
        }
      }
    }


    /*
    mergeObjects: (dest, src) ->
      for k, v of src
        if typeof v is 'object' and dest.hasOwnProperty k
          @mergeObjects dest[k], v
        else
          dest[k] = v
     */

    QedaElement.prototype.addPattern = function(packageDef) {
      var cap, handler, i, len, p, ref, results;
      if (packageDef.pattern == null) {
        return;
      }
      ref = this.lib.patternDefs;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        p = ref[i];
        cap = p.regexp.exec(packageDef.pattern);
        if (cap) {
          this.patterns[cap[0]] = this.pattern = [];
          handler = require("./pattern/" + this.lib.patternStyle + "/" + p.handler);
          results.push(handler.apply(null, [this].concat(slice.call(cap.slice(1)))));
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaElement.prototype.setLayer = function(layer) {
      this.layer = layer;
      return this.pattern.push({
        tag: 'layer',
        name: layer
      });
    };

    QedaElement.prototype.rect = function(x, y, w, h) {
      return this.pattern.push({
        tag: 'rect',
        x: x,
        y: y,
        w: w,
        h: h
      });
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
